var widgetAPI = new Common.API.Widget();
var tvKey = new Common.API.TVKeyValue();
var pluginAPI = new Common.API.Plugin();

var cntTopMenu = 4;                 // 탑 메뉴 페이지 수
var cntContentMenu = new Array(4); // 서브 메뉴 페이지 수 정의
cntContentMenu[0]			= 4; 
cntContentMenu[1]			= 4;  
cntContentMenu[2]			= 4; 
cntContentMenu[3]			= 4; 
var maxContentMenu		= new Array(); // 각 서브별 컨텐츠 페이지 정의
maxContentMenu[0]	= [0,0,0,0];
maxContentMenu[1]	= [3,3,3,3];
maxContentMenu[2]	= [2,2,2,3];
maxContentMenu[3]	= [2,4,2,4];

var curArea 			= 0;			// 현재 포커스 장소 1: 1단계 메뉴 , 2: 2단계 메뉴 , 3: 3단계 상세 페이지
var curTopSeq 		= 0;				// 1단계 메뉴 : 현재 Index
var selTopSeq     = -1;                 // 1단계 메뉴 : 선택된 Index
var curMiddleSeq 	= 0;				// 2단계 메뉴 : 현재 Index
var selMiddleSeq  = -1;                 // 2단계 메뉴 : 선택된 Index
var curContentSeq = 0;                  // 컨텐츠 : Index

//한영 버젼
var version;

var Main = 
{
  pluginAPI : null
}

Main.onLoad = function()
{
    Main.pluginAPI = document.getElementById("pluginObjectTVMW");
    //NNaviPlugin = document.getElementById("pluginObjectNNavi");

	window.document.onkeydown = nav;
    
    if (Main.getCountry() == "KR") {   // 한국일경우의 처리
        version = "kor";
    } else {
        version = "eng";
    }
        
    $('#Wrap').load("html/"+version+"_body.html", function() {
		var curObj = $("#idSubMenu0");
        curObj.focus();
        $(curObj).attr("src", $(curObj).attr("src").replace(/_normal.png/, "_over.png"));
        
        if(version == "kor"){
            $("#exit").attr("src", $("#exit").attr("src").replace("keyhelp", "h_keyhelp"));
            $("#back").attr("src", $("#back").attr("src").replace("keyhelp", "h_keyhelp"));
        }
          
	});
        
    widgetAPI.sendReadyEvent(); //무조건 넣어야함(안넣으면 연결이안됨)

   window.onShow = Main.initKeys;

   //setTimeout("setVolumeKeyEvent()", 500);
    
}

/*
function setVolumeKeyEvent() {
    pluginAPI.SetBannerState(1);
    NNaviPlugin.SetBannerState(2);
    pluginAPI.unregistKey(7); //unregister volume up button
    pluginAPI.unregistKey(11); //unregister volume down button
    pluginAPI.unregistKey(27); //unregister mute button

}
*/

Main.initKeys = function()
{
    //get Nav plugin
    var NNaviPlugin = document.getElementById("pluginObjectNNavi");
    
    pluginAPI.SetBannerState(1);
    NNaviPlugin.SetBannerState(2);
   
    // Unregister for not processing the following keys in Flash Object
    /*pluginAPI.unregistKey(7);  //unregister volume up button
    pluginAPI.unregistKey(11); //unregister volume down button
    pluginAPI.unregistKey(27); //unregister mute button 
    pluginAPI.unregistKey(262); //unregister MENU key
    pluginAPI.unregistKey(147); //unregister INFO.L key
    pluginAPI.unregistKey(45);  //unregister EXIT key    
	*/
	
	// SH 2012.02.20
    pluginAPI.unregistKey(tvKey.KEY_VOL_UP);  //unregister volume up button
    pluginAPI.unregistKey(tvKey.KEY_VOL_DOWN); //unregister volume down button
    pluginAPI.unregistKey(tvKey.KEY_MUTE); //unregister mute button 
    pluginAPI.unregistKey(tvKey.KEY_MENU); //unregister MENU key
    pluginAPI.unregistKey(tvKey.KEY_INFOLINK); //unregister INFO.L key
    pluginAPI.unregistKey(tvKey.KEY_EXIT);  //unregister EXIT key    
    
    pluginAPI.unregistKey(tvKey.KEY_CONTENT);  //unregister Smart Hub key
}




Main.onUnload = function(){}

Main.getCountry = function() {

 var str = window.location.search;
 alert ("w.l.s : " + str);
 var returnVar = [];
 var results = str.split('&');

 for(i=0; i < results.length; i++){
     var result = results[i].split('=');
        returnVar[i] = {vars : result[0], values : result[1]};
 }

    return returnVar[0].values;
}

// 1단계 메뉴 ON
function onTopMenu(sq) {
	var obj = $("#idSubMenu"+sq);
	if (selTopSeq == sq)
		$(obj).attr("src", $("#idSubMenu"+sq).attr("src").replace("_select.png", "_over.png"));
	else
		$(obj).attr("src", $("#idSubMenu"+sq).attr("src").replace("_normal.png", "_over.png"));
	
}

// 1단계 메뉴 OFF
function offTopMenu(sq) {
	var obj = $("#idSubMenu"+sq);
	if(selTopSeq == sq)
		$("#idSubMenu"+sq).attr("src", $("#idSubMenu"+sq).attr("src").replace("_over.png", "_select.png"));
	else {
		$("#idSubMenu"+sq).attr("src", $("#idSubMenu"+sq).attr("src").replace("_over.png", "_normal.png"));
	}
}

// 1단계 메뉴 Select
function selectTopMenu(sq) {
	var obj = $("#idSubMenu"+sq);
	if($(obj).attr('src').indexOf('_over.png') > 0)
		$("#idSubMenu"+sq).attr("src", $("#idSubMenu"+sq).attr("src").replace("_over.png", "_select.png"));
	else
		$("#idSubMenu"+sq).attr("src", $("#idSubMenu"+sq).attr("src").replace("_normal.png", "_select.png"));
}

// 1단계 메뉴 Un Select
function unselectTopMenu(sq) {
	var obj = $("#idSubMenu"+sq);
	if(sq != -1)
	$("#idSubMenu"+sq).attr("src", $("#idSubMenu"+sq).attr("src").replace("_select.png", "_normal.png"));
}	

// 2단게 메뉴 ON
function onMiddleMenu(sq) {
	var obj = $("#idContent"+sq);
	if ( selMiddleSeq == sq) {
		if($(obj).attr('src').indexOf("_normal.png") > 0)
			$(obj).attr("src", $("#idContent"+sq).attr("src").replace("_normal.png", "_over.png"));
		else
			$(obj).attr("src", $("#idContent"+sq).attr("src").replace("_select.png", "_over.png"));
	} else {
		$(obj).attr("src", $("#idContent"+sq).attr("src").replace("_normal.png", "_over.png"));
	}
	
}

// 2단계 메뉴 OFF
function offMiddleMenu(sq) {
	var obj = $("#idContent"+sq);
	if(selMiddleSeq == sq) {
		$("#idContent"+sq).attr("src", $("#idContent"+sq).attr("src").replace("_over.png", "_select.png"));
	} else {
		$("#idContent"+sq).attr("src", $("#idContent"+sq).attr("src").replace("_over.png", "_normal.png"));
	}

}

// 2단계 메뉴 Select
function selectMiddleMenu(sq) {
	var obj = $("#idContent"+sq);
		$("#idContent"+sq).attr("src", $("#idContent"+sq).attr("src").replace("_over.png", "_select.png"));

}

// 1단계 메뉴 Un Select
function unselectMiddleMenu(sq) {
	var obj = $("#idContent"+sq);
	if(sq != -1)
		$("#idContent"+sq).attr("src", $("#idContent"+sq).attr("src").replace("_select.png", "_normal.png"));
}

// 키보드 컨트롤 
function nav() {
    
    var keyMap = getkeyMap(event.keyCode);
         
    if(/*(keyMap == "kEsc")||*/(keyMap == "kBack")){
        widgetAPI.blockNavigation(event);       //해당키 본래기능 막기
    }
        
    switch (curArea)
    {
        case 0 : //////// 첫번째 메뉴
            if((keyMap == "kUp") /*|| (keyMap == "kDown") */){
            }else{
                if (keyMap == "kBack")
                {
                    doExit();
                }
                else if ( (keyMap == "kLeft") || (keyMap == "kRight") )
                {
                    offTopMenu(curTopSeq);
                    if (keyMap == "kLeft")
                    {
                        curTopSeq--;
                        if (curTopSeq < 0) curTopSeq = 0;
                    }
                    else if (keyMap == "kRight")
                    {
                        curTopSeq++;
                        if (curTopSeq >= cntTopMenu) curTopSeq = cntTopMenu-1;
                    }
                    onTopMenu(curTopSeq);
                    goStep2(curTopSeq);

                }
                else if (keyMap == "kEnter" || (keyMap == "kDown"))
                {
                    curArea = 1;
                    if(curTopSeq != selTopSeq && selTopSeq != -1)
                        unselectTopMenu(selTopSeq);
                        
                    selectTopMenu(curTopSeq);
                    selTopSeq = curTopSeq;
                    selMiddleSeq = -1;
                    onMiddleMenu(curMiddleSeq);
                }
            }
            event.keyCode = 0;
            return false;
            break;
        case 1 : /////// 두번째 메뉴
            /*
            if( (keyMap == "kDown") || (keyMap == "kUp") ){
            }
            else */
            if (keyMap == "kBack"|| (keyMap == "kUp") )
            {
                doBack();
            }
            else if ( (keyMap == "kLeft") || (keyMap == "kRight") )
            {
                offMiddleMenu(curMiddleSeq);
                if (keyMap == "kLeft")
                {
                    curMiddleSeq--;
                    if (curMiddleSeq < 0) curMiddleSeq = 0;
                }
                else if (keyMap == "kRight")
                {
                    curMiddleSeq++;
                    if (curMiddleSeq >= cntContentMenu[curTopSeq]) curMiddleSeq = cntContentMenu[curTopSeq] - 1;
                }
                onMiddleMenu(curMiddleSeq);
            }
            else if ((keyMap == "kEnter") || (keyMap == "kDown") )
            {
                if(curMiddleSeq != selMiddleSeq && selMiddleSeq != -1)
                    unselectMiddleMenu(selMiddleSeq);
                selMiddleSeq = curMiddleSeq;
                offMiddleMenu(curMiddleSeq);
                selectMiddleMenu(curMiddleSeq);
                goStep3(curTopSeq, curMiddleSeq, curContentSeq);    //해당 컨텐츠 불러오기
                curArea = 2;    //현재 포커스를 컨텐츠 단계로 넘김
                curContentSeq=0;      //컨텐츠 페이지 초기화
            }
            
            event.keyCode = 0 ;
            return false;
            break;
        case 2 :  ///// 컨텐츠
            switch (keyMap) {
                case "kEnter" :
                //컨텐츠 페이지 수가 더 남아 있다면
                if(maxContentMenu[curTopSeq][curMiddleSeq]>curContentSeq){ 
                    curContentSeq++;
                }else{
                    curContentSeq = 0;
                }
                //해당 컨텐츠 불러오기
                goStep3(curTopSeq, curMiddleSeq, curContentSeq);
                break;
                case "kLeft" :
                //현재 컨텐츠 페이지가 첫페이지면
                if(curContentSeq == 0){ 
                    curContentSeq = 0;
                }else{
                    curContentSeq--;
                }
                //해당 컨텐츠 불러오기
                goStep3(curTopSeq, curMiddleSeq, curContentSeq);
                break;
                case "kRight" :
                //현재 컨텐츠 페이지가 마지막 페이지면
                if(maxContentMenu[curTopSeq][curMiddleSeq] == curContentSeq){ 
                    curContentSeq = maxContentMenu[curTopSeq][curMiddleSeq];
                }else{
                    curContentSeq++;
                }
                //해당 컨텐츠 불러오기
                goStep3(curTopSeq, curMiddleSeq, curContentSeq);
                break;
                
                case "kUp" :
                case "kBack" :
                    doBack();
                break;
                
                case "kDown" :
                break;
                
            }
            break;
   }
}

// 2단계 메뉴
function goStep2(seq){
		$('#contWrap').load("html/"+version+"/menu" + seq + "/submenu" + seq + ".html");
}

// 3단계 상세 페이지
function goStep3(seq, subSeq, contSeq){
	$('#contSub').load("html/"+version+"/menu" + seq + "/content" + subSeq + "_" +contSeq+ ".html", function() {
		$('#idContRight').focus();
		$('#idContRight').scrollTop(0);
        
      if(maxContentMenu[seq][subSeq]>0){      //컨텐츠 페이지가 1이상일 경우
            document.getElementById('Paging').style.visibility = "visible"; //페이지 숫자 보이기
            document.getElementById('PrevNext').style.visibility = "visible"; 
            var pageTotal = eval(maxContentMenu[seq][subSeq]+1);
            var pageNumber = contSeq+1;
            document.getElementById('pageNumber').innerHTML = pageNumber+"/"+pageTotal;
           
       }else{

            $("#prev").attr("src", $("#prev").attr("src").replace("prev", "temp"));
            $("#enter").attr("src",$("#enter").attr("src").replace("enter", "temp"));
            $("#next").attr("src", $("#next").attr("src").replace("next", "temp"));
       }
        
	});
}

// 백 키 눌렀을 때
function doBack(){
	if( curArea == 0 ){ // exit
		doExit();
	}else if( curArea == 1 ){       //두번째 라인에서 백이면
		offMiddleMenu(curMiddleSeq);
		curMiddleSeq = 0;
        curArea = 0;
		$("#idSubMenu"+selTopSeq).attr("src", $("#idSubMenu"+selTopSeq).attr("src").replace("_select.png", "_over.png"));
        selTopSeq = -1;   //선택된것 초기화
	}else if( curArea == 2 ){       //컨텐츠에서 백이면
		curArea = 1;
        curContentSeq = 0;
        document.getElementById('Paging').style.visibility = "hidden";  //페이지 숫자 숨기기
        document.getElementById('PrevNext').style.visibility = "hidden"; 
		$('#contSub').load("html/"+version+"/Exit_content.html");   //컨텐츠 초기화
        $("#idContent"+selMiddleSeq).attr("src", $("#idContent"+selMiddleSeq).attr("src").replace("_select.png", "_over.png"));
        selMiddleSeq = -1;   //선택된것 초기화
        
        $("#prev").attr("src", $("#prev").attr("src").replace("temp", "prev"));
        $("#enter").attr("src",$("#enter").attr("src").replace("temp", "enter"));
        $("#next").attr("src", $("#next").attr("src").replace("temp", "next"));
        
    }
	
}

// 나가기 키를 눌렀을 때
function doExit(){
   
    widgetAPI.sendReturnEvent();    //스마트허브로 나가게끔
   //widgetAPI.sendExitEvent();    //TV상으로 나갈때
}

//리모컨 키를 소스에서 사용할 수 있도록 변환하는 메서드
function getkeyMap(kC)
{
	var keyInMap = "";
	if (kC == 88) keyInMap = "kBack";
	else if (kC == 29443) keyInMap = "kEnter";
	else if (kC ==  45) keyInMap = "kEsc";
	else if (kC ==  4) keyInMap = "kLeft";
	else if (kC == 29460) keyInMap = "kUp";
	else if (kC ==  5) keyInMap = "kRight";
	else if (kC == 29461) keyInMap = "kDown";
 	else keyInMap = "kEtc";
	return keyInMap;

}